<?php
/**
* @package phpBB Extension - Topic Bookmark Count
* @copyright (c) 2023 Sniper_E - http://sniper-e.net
* @license http://opensource.org/licenses/gpl-2.0.php GNU General Public License v2
*/

namespace sniper\topicbookmarks\event;

use Symfony\Component\EventDispatcher\EventSubscriberInterface;

/**
* Event listener
*/
class listener implements EventSubscriberInterface
{
	/** @var \phpbb\user */
	protected $user;

	/** @var \phpbb\template\template */
	protected $template;

	/** @var \phpbb\db\driver\driver_interface */
	protected $db;

	/**
	* Constructor
	*
	* @param \phpbb\user                       	$user
	* @param \phpbb\template\template          	$template
	* @param \phpbb\db\driver\driver_interface 	$db
	*
	*/
	public function __construct(\phpbb\user $user, \phpbb\template\template $template, \phpbb\db\driver\driver_interface $db)
	{
		$this->user     	= $user;
		$this->template 	= $template;
		$this->db       	= $db;
	}

	static public function getSubscribedEvents()
	{
		return array(
			'core.viewtopic_get_post_data' => 'viewtopic_modify_page_title',
		);
	}

	public function viewtopic_modify_page_title($event)
	{
		$this->user->add_lang_ext('sniper/topicbookmarks', 'common');-

		$topic_id = $event['topic_id'];

		$sql = 'SELECT COUNT(*) AS bookmark_count FROM ' . BOOKMARKS_TABLE . ' WHERE topic_id = ' . (int) $topic_id;
		$result = $this->db->sql_query($sql);
		$bookmark_count = (int) $this->db->sql_fetchfield('bookmark_count');
	
		$this->template->assign_vars(array(
			'BOOKMARK_COUNT' => $bookmark_count,
		));
	}
}
